state("3D Frog Frenzy", "1999")
{
	int minutes : 0x8c038;
	int seconds : 0x8c034;
	int sixtieths : 0x8c03c;
	int lives : 0x8c078;
	int state : 0x8c02c;
	int level : 0x6c27c;
	int score : 0x6c414;
}

startup
{
	settings.Add("fullgame", true, "Full-Game Run (split after each level)");
	settings.Add("scorerun", false, "Score Speedrun (split at a given score)");
	settings.Add("1kscore", false, "1,000 points", "scorerun");
	settings.Add("5kscore", false, "5,000 points", "scorerun");
	settings.Add("10kscore", false, "10,000 points", "scorerun");
	refreshRate = 60;
	vars.startingMinutes = 0;
	vars.cumulativeTime = 0;
}

update
{
	if (current.lives > 0)
	{
		if (current.state == 1 && old.state != 1)
		{
			vars.startingMinutes = current.minutes + Math.Ceiling(current.seconds / 60.0);
		}
		
		if (current.minutes > old.minutes && current.state == 0)
		{
			vars.startingMinutes += 1;
		}
		
		if
		(
			(
				current.state == 2 ||
				current.state == 4 ||
				current.state == 5 ||
				current.state == 6
			) &&
			old.state == 0
		)
		{
			vars.cumulativeTime += 3600 * (vars.startingMinutes - current.minutes) - 60 * current.seconds - current.sixtieths;
		}
	}
}

init
{
	print("MODULE MEM SIZE " + modules.First().ModuleMemorySize.ToString());
	version = "1999";
}

split
{
	if (settings["fullgame"])
	{
		if (current.level == 21)
		{
			return (current.state == 6 && old.state != 6);
		}
		else
		{
			return (current.state == 1 && old.state == 8 && current.lives > 0);
		}
	}
	
	if (settings["scorerun"])
	{
		if (settings["1kscore"])
		{
			return (current.score >= 1000 && old.score < 1000);
		}
		if (settings["5kscore"])
		{
			return (current.score >= 5000 && old.score < 5000);
		}
		if (settings["10kscore"])
		{
			return (current.score >= 10000 && old.score < 10000);
		}
	}
}

start
{
	if (current.level == 0 && current.state == 0 && current.lives > 0)
	{
		vars.startingMinutes = current.minutes + Math.Ceiling(current.seconds / 60.0);
		vars.cumulativeTime = 0;
		return true;
	}
}

isLoading
{
	return true;
}

gameTime
{
	if (current.state == 0)
	{
		return new TimeSpan(0, 0, 0, (int)(vars.cumulativeTime + (3600 * ((int)vars.startingMinutes - current.minutes) - 60 * current.seconds - current.sixtieths)), 0);
	}
	else
	{
		return new TimeSpan(0, 0, 0, (int)(vars.cumulativeTime), 0);
	}
}